/*!
 * docsify-plugin-ethicalads
 * v1.0.1
 * https://jhildenbiddle.github.io/docsify-plugin-ethicalads/
 * (c) 2022-2024 John Hildenbiddle
 * MIT license
 */
(function() {
    "use strict";
    function ownKeys(object, enumerableOnly) {
        var keys = Object.keys(object);
        if (Object.getOwnPropertySymbols) {
            var symbols = Object.getOwnPropertySymbols(object);
            enumerableOnly && (symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            }))), keys.push.apply(keys, symbols);
        }
        return keys;
    }
    function _objectSpread2(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = null != arguments[i] ? arguments[i] : {};
            i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
                _defineProperty(target, key, source[key]);
            })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
            }));
        }
        return target;
    }
    function _defineProperty(obj, key, value) {
        if (key in obj) {
            Object.defineProperty(obj, key, {
                value: value,
                enumerable: true,
                configurable: true,
                writable: true
            });
        } else {
            obj[key] = value;
        }
        return obj;
    }
    function _slicedToArray(arr, i) {
        return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
    }
    function _toConsumableArray(arr) {
        return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
    }
    function _arrayWithoutHoles(arr) {
        if (Array.isArray(arr)) return _arrayLikeToArray(arr);
    }
    function _arrayWithHoles(arr) {
        if (Array.isArray(arr)) return arr;
    }
    function _iterableToArray(iter) {
        if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
    }
    function _iterableToArrayLimit(arr, i) {
        var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
        if (_i == null) return;
        var _arr = [];
        var _n = true;
        var _d = false;
        var _s, _e;
        try {
            for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
                _arr.push(_s.value);
                if (i && _arr.length === i) break;
            }
        } catch (err) {
            _d = true;
            _e = err;
        } finally {
            try {
                if (!_n && _i["return"] != null) _i["return"]();
            } finally {
                if (_d) throw _e;
            }
        }
        return _arr;
    }
    function _unsupportedIterableToArray(o, minLen) {
        if (!o) return;
        if (typeof o === "string") return _arrayLikeToArray(o, minLen);
        var n = Object.prototype.toString.call(o).slice(8, -1);
        if (n === "Object" && o.constructor) n = o.constructor.name;
        if (n === "Map" || n === "Set") return Array.from(o);
        if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
    }
    function _arrayLikeToArray(arr, len) {
        if (len == null || len > arr.length) len = arr.length;
        for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
        return arr2;
    }
    function _nonIterableSpread() {
        throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    function _nonIterableRest() {
        throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var e = [], t = [];
    function n(n, r) {
        if (n && "undefined" != typeof document) {
            var a, s = !0 === r.prepend ? "prepend" : "append", d = !0 === r.singleTag, i = "string" == typeof r.container ? document.querySelector(r.container) : document.getElementsByTagName("head")[0];
            if (d) {
                var u = e.indexOf(i);
                -1 === u && (u = e.push(i) - 1, t[u] = {}), a = t[u] && t[u][s] ? t[u][s] : t[u][s] = c();
            } else a = c();
            65279 === n.charCodeAt(0) && (n = n.substring(1)), a.styleSheet ? a.styleSheet.cssText += n : a.appendChild(document.createTextNode(n));
        }
        function c() {
            var e = document.createElement("style");
            if (e.setAttribute("type", "text/css"), r.attributes) for (var t = Object.keys(r.attributes), n = 0; n < t.length; n++) e.setAttribute(t[n], r.attributes[t[n]]);
            var a = "prepend" === s ? "afterbegin" : "beforeend";
            return i.insertAdjacentElement(a, e), e;
        }
    }
    var css = '/* Variables */\n/* ---------------------------------------- */\n:root {\n    --ea-background: #f7f7f7;\n    --ea-border-color: #ededed;\n    --ea-border-radius: 4px;\n    --ea-callout-background: #ededed;\n    --ea-callout-color: \'inherit\';\n    --ea-callout-font-size: 10px;\n    --ea-color: #444;\n    --ea-font-size: 12px;\n    --ea-line-height: 1.4;\n    --ea-margin: 1em;\n    --ea-sidebar-inset: 300px;\n    --ea-sidebar-toggle-inset: 45px;\n    --ea-strong-color: var(--theme-color, #42b983);\n\n    /* Dark */\n    --ea-dark-background: #1f282d;\n    --ea-dark-border-color: #384951;\n    --ea-dark-callout-background: #384951;\n    --ea-dark-callout-color: \'inherit\';\n    --ea-dark-color: #fff;\n    --ea-dark-strong-color: var(--ea-strong-color);\n}\n\n/* Docsify Themeable */\n:root:where(.themeable) {\n    --ea-sidebar-inset: var(--sidebar-width);\n    --ea-sidebar-toggle-inset: 0;\n}\n\n\n/* Global */\n/* ---------------------------------------- */\n[data-ea-publisher][class] {\n    position: relative;\n    margin: var(--ea-margin);\n    border-radius: var(--ea-border-radius);\n    line-height: var(--ea-line-height);\n    vertical-align: top;\n}\n\n[data-ea-publisher][class] a,\n[data-ea-publisher][class] a :not(strong) {\n    font-weight: normal;\n}\n\n[data-ea-publisher][class] .ea-placement[class] {\n    font-size: var(--ea-font-size);\n}\n\n[data-ea-publisher][class] .ea-placement[class] .ea-content {\n    margin: 0 0 0.5em 0;\n    border-color: var(--ea-border-color);\n    border-radius: var(--ea-border-radius);\n    background: var(--ea-background);\n    color: inherit;\n}\n\n[data-ea-publisher][class] .ea-placement[class] .ea-content a {\n    color: var(--ea-color);\n}\n\n[data-ea-publisher][class] .ea-placement[class] .ea-content a strong {\n    color: var(--ea-strong-color);\n}\n\n[data-ea-publisher][class] .ea-placement[class] .ea-callout {\n    margin: 0;\n}\n\n[data-ea-publisher][class] .ea-placement[class] .ea-callout a {\n    font-style: normal;\n    font-size: var(--ea-callout-font-size);\n    color: var(--ea-callout-color);\n}\n\n\n/* Global - Image Ad */\n/* ---------------------------------------- */\n[data-ea-type][class] .ea-type-image .ea-content > a > img {\n    display: block;\n    margin: auto;\n    border-radius: calc(var(--ea-border-radius) / 2);\n}\n\n[data-ea-type][class].horizontal .ea-type-image .ea-content > a > img {\n    margin-right: 1em;\n}\n\n\n/* Global - Contained Callout  */\n/* ---------------------------------------- */\n.sidebar [data-ea-publisher][class] .ea-placement[class],\n[data-ea-style="stickybox"] .ea-placement[class] {\n    /* Allows callout color to be set to \'inherit\' */\n    color: var(--ea-color);\n}\n\n.sidebar [data-ea-publisher][class] .ea-placement[class] .ea-content,\n[data-ea-style="stickybox"] .ea-placement.ea-type-image[class] .ea-content {\n    margin: 0;\n    padding-bottom: 2.75em;\n}\n\n.sidebar [data-ea-publisher][class] .ea-placement[class] .ea-callout,\n[data-ea-style="stickybox"] .ea-placement[class] .ea-callout {\n    position: absolute;\n    bottom: 0;\n    right: 0;\n    margin: 0;\n    padding: 0.15em 1em 0.25em;\n    border-top-left-radius: var(--ea-border-radius);\n    border-bottom-right-radius: var(--ea-border-radius);\n    background: var(--ea-callout-background);\n}\n\n.sidebar [data-ea-publisher].bordered .ea-placement[class] .ea-callout,\n[data-ea-style="stickybox"].bordered .ea-placement[class] .ea-callout {\n    bottom: 1px;\n    right: 1px;\n}\n\n\n/* Style: Fixed Footer */\n/* ---------------------------------------- */\n[data-ea-style="fixedfooter"][class] .ea-placement[class] {\n    right: 0;\n    left: var(--ea-sidebar-inset);\n    width: auto;\n    padding-left: 0;\n    background: var(--ea-background);\n    transition: all 250ms;\n}\n\n[data-ea-style="fixedfooter"][class].bordered .ea-placement[class] {\n    border-top: 1px solid var(--ea-border-color);\n}\n\n[data-ea-style="fixedfooter"][class] .ea-placement[class] .ea-content {\n    border: 0;\n    border-radius: 0;\n    margin: 0;\n}\n\n[data-ea-style="fixedfooter"][class] .ea-placement[class] .ea-fixedfooter-hide {\n    color: var(--ea-color);\n}\n\n[data-ea-style="fixedfooter"][class] .ea-placement[class] .ea-fixedfooter-hide span {\n    border-color: var(--ea-color);\n}\n\nbody.close [data-ea-style="fixedfooter"][class] .ea-placement[class] {\n    left: 0;\n    padding-left: var(--ea-sidebar-toggle-inset);\n}\n\n\n/* Style: Stickybox */\n/* ---------------------------------------- */\n[data-ea-style="stickybox"] .ea-placement[class] .ea-stickybox-hide {\n    top: 0px;\n    right: 0px;\n    height: 20px;\n    width: 20px;\n    border: none;\n    border-radius: 0 calc(var(--ea-border-radius) / 2) 0 calc(var(--ea-border-radius) / 2);\n    background: var(--ea-callout-background);\n    color: var(--ea-color);\n    font-size: 16px;\n    line-height: 17px;\n}\n\n[data-ea-style="stickybox"].bordered .ea-placement[class] .ea-stickybox-hide {\n    top: 1px;\n    right: 1px;\n}\n\n\n/* Scoped: Sidebar */\n/* ---------------------------------------- */\n.sidebar {\n    --ea-margin: 1em 15px;\n}\n\n.sidebar [data-ea-publisher][class] {\n    display: block;\n    position: relative;\n    order: 1;\n}\n\n.sidebar [data-ea-publisher][class].flat {\n    --ea-margin: 1em 0;\n}\n\n.sidebar .ea-placement[class] {\n    display: block;\n}\n\n.sidebar .ea-placement[class] .ea-content {\n    max-width: none;\n}\n\n.sidebar [data-ea-publisher][class].flat .ea-content {\n    border-radius: 0;\n}\n\n.sidebar [data-ea-publisher][class].flat.horizontal .ea-content > a > img {\n    border-radius: 0;\n}\n\n.sidebar [data-ea-publisher][class].flat .ea-placement[class] .ea-callout {\n    border-bottom-right-radius: 0;\n}\n\n/* Docsify Themeable */\n:where(.themeable) .sidebar {\n    --ea-background: hsl(var(--mono-hue), var(--mono-saturation), 94%);\n    --ea-callout-background: hsl(var(--mono-hue), var(--mono-saturation), 89%);\n    --ea-margin: 1em 0 0 0;\n}\n\n:where(.themeable) .sidebar [data-ea-publisher][class].flat {\n    --ea-margin: 0 -25px;\n}\n\n\n/* Scoped: Sidebar - Image Ad */\n/* ---------------------------------------- */\n.sidebar .horizontal .ea-type-image {\n    display: block;\n}\n\n.sidebar .horizontal .ea-type-image .ea-content {\n    padding-top: 0;\n    padding-left: 0;\n}\n\n.sidebar .horizontal .ea-type-image .ea-content > a > img {\n    border-top-right-radius: 0;\n    border-bottom-left-radius: 0;\n}\n\n.sidebar .horizontal .ea-type-image .ea-content .ea-text {\n    margin-top: 0.5em;\n}\n\n\n/* Scoped: Sidebar - Text Ad */\n/* ---------------------------------------- */\n.sidebar .ea-type-text .ea-content {\n    padding-right: 15px;\n    padding-left: 15px;\n}\n\n\n/* Theme: Dark */\n/* ---------------------------------------- */\n.dark {\n    --ea-background: var(--ea-dark-background);\n    --ea-border-color: var(--ea-dark-border-color);\n    --ea-callout-background: var(--ea-dark-callout-background);\n    --ea-callout-color: var(--ea-dark-callout-color);\n    --ea-color: var(--ea-dark-color);\n    --ea-strong-color: var(--ea-dark-strong-color);\n}\n\n/* Adaptive */\n@media (prefers-color-scheme: dark) {\n    [data-ea-publisher][class].adaptive {\n        --ea-background: var(--ea-dark-background);\n        --ea-border-color: var(--ea-dark-border-color);\n        --ea-callout-background: var(--ea-dark-callout-background);\n        --ea-callout-color: var(--ea-dark-callout-color);\n        --ea-color: var(--ea-dark-color);\n        --ea-strong-color: var(--ea-dark-strong-color);\n    }\n}\n';
    n(css, {
        container: "body",
        prepend: true,
        attributes: {
            "data-src": "docsify-plugin-ethicalads"
        }
    });
    var defaults = {
        eaCampaignTypes: null,
        eaForceCampaign: null,
        eaForcedAd: null,
        eaKeywords: null,
        eaPublisher: null,
        eaStyle: null,
        eaType: null,
        class: null,
        id: null,
        style: null,
        showFooter: false,
        showSidebar: true,
        placements: [],
        clientURL: "https://media.ethicalads.io/media/client/ethicalads.min.js"
    };
    var adHTMLAttrs = [ "class", "id", "style" ];
    var adIgnoreKeys = [ "clientURL", "placements", "showFooter", "showSidebar" ];
    function camelToDashCase(str) {
        return str.replace(/([a-z])([A-Z])/g, (function(m) {
            return m[0] + "-" + m[1].toLowerCase();
        }));
    }
    function isObject(obj) {
        return Boolean(obj && obj.constructor.name === "Object");
    }
    function renderAd(config) {
        var sidebarAd = document.querySelector(".sidebar [data-ea-publisher].loaded");
        var isSkipFixedFooterAd = config.eaStyle === "fixedfooter" && document.querySelector('[data-ea-style="fixedfooter"]');
        var isSkipStickyBoxAd = config.eaStyle === "stickybox" && document.querySelector('[data-ea-style="stickybox"]');
        var insertMap = {
            appendTo: "beforeend",
            prependTo: "afterbegin",
            insertBefore: "beforebegin",
            insertAfter: "afterend"
        };
        if (isSkipFixedFooterAd || isSkipStickyBoxAd) {
            return;
        }
        var adElm = document.createElement("div");
        var dataAttrs = Object.keys(config).filter((function(key) {
            return config[key] && /^ea[A-Z]/.test(key);
        }));
        var htmlAttrs = adHTMLAttrs.filter((function(key) {
            return config[key];
        }));
        dataAttrs.forEach((function(v) {
            var dataAttr = camelToDashCase(v);
            adElm.setAttribute("data-".concat(dataAttr), config[v]);
        }));
        htmlAttrs.forEach((function(v) {
            adElm.setAttribute(v, config[v]);
        }));
        for (var _i = 0, _Object$entries = Object.entries(insertMap); _i < _Object$entries.length; _i++) {
            var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2), option = _Object$entries$_i[0], insertPosition = _Object$entries$_i[1];
            var targetVal = config[option];
            var targetElm = typeof targetVal === "string" ? document.querySelector(targetVal) : targetVal;
            if (targetElm) {
                var matchElm = option === "appendTo" || option === "prependTo" ? targetElm : targetElm.parentNode;
                var isSkipSidebarAd = sidebarAd && matchElm.matches(".sidebar, .sidebar *");
                !isSkipSidebarAd && targetElm.insertAdjacentHTML(insertPosition, adElm.outerHTML);
            }
        }
    }
    (function() {
        var docsifyEthicalAds = function docsifyEthicalAds(hook, vm) {
            var settings = _objectSpread2(_objectSpread2({}, defaults), window.$docsify.ethicalAds || {});
            var adDefaults = Object.fromEntries(Object.entries(settings).filter((function(_ref) {
                var _ref2 = _slicedToArray(_ref, 2), key = _ref2[0], value = _ref2[1];
                return value && !adIgnoreKeys.includes(key);
            })));
            hook.init((function() {
                if (settings.eaPublisher) {
                    if (settings.showFooter) {
                        var _defaults = {
                            appendTo: "main",
                            eaStyle: "fixedfooter",
                            eaType: "text",
                            class: "adaptive bordered"
                        };
                        var config = isObject(settings.showFooter) ? _objectSpread2(_objectSpread2({}, _defaults), settings.showFooter) : _defaults;
                        settings.placements.unshift(config);
                    }
                    if (settings.showSidebar) {
                        var _defaults2 = {
                            insertBefore: ".sidebar-nav",
                            eaType: "image",
                            class: "adaptive flat horizontal"
                        };
                        var _config = isObject(settings.showSidebar) ? _objectSpread2(_objectSpread2({}, _defaults2), settings.showSidebar) : _defaults2;
                        settings.placements.unshift(_config);
                    }
                }
            }));
            hook.beforeEach((function() {
                var eaStyleElmFixed = document.querySelector('head style[data-src="ethicalads"]');
                if (!eaStyleElmFixed) {
                    var styleElms = _toConsumableArray(document.querySelectorAll("head style"));
                    styleElms.forEach((function(styleElm) {
                        var hasLoadedSelector = /\[data-ea-publisher]\.loaded/.test(styleElm.textContent);
                        if (hasLoadedSelector) {
                            styleElm.textContent = styleElm.textContent.replace(/\.loaded/g, "");
                            styleElm.setAttribute("data-src", "ethicalads");
                        }
                    }));
                }
            }));
            hook.doneEach((function() {
                settings.placements.forEach((function(placement, i) {
                    var config = _objectSpread2(_objectSpread2({}, adDefaults), placement);
                    if (config.eaPublisher) {
                        renderAd(config);
                    } else {
                        console.error("docsify-plugin-ethicalads: Missing publisher ID", settings.placements[i]);
                    }
                }));
                var eaElmsWithoutPublisher = _toConsumableArray(document.querySelectorAll("[data-ea-type]:not([data-ea-publisher])"));
                if (eaElmsWithoutPublisher.length) {
                    if (settings.eaPublisher) {
                        eaElmsWithoutPublisher.forEach((function(elm) {
                            elm.setAttribute("data-ea-publisher", settings.eaPublisher);
                        }));
                    } else {
                        console.error("docsify-plugin-ethicalads: Missing publisher ID", eaElmsWithoutPublisher);
                    }
                }
                if (window.ethicalads) {
                    var loadedAdElms = _toConsumableArray(document.querySelectorAll("[data-ea-publisher].loaded, [data-ea-type].loaded"));
                    var loadedScriptElms = _toConsumableArray(document.querySelectorAll('script[src*="ethicalads.io/api/"]'));
                    var unloadedAdElms = [];
                    if (loadedAdElms.length) {
                        loadedAdElms.forEach((function(elm) {
                            elm.classList.remove("loaded");
                            unloadedAdElms.push(elm);
                        }));
                        loadedScriptElms.forEach((function(elm) {
                            return elm.parentNode.removeChild(elm);
                        }));
                    }
                    unloadedAdElms.concat.apply(unloadedAdElms, _toConsumableArray(document.querySelectorAll("[data-ea-publisher]:not(.loaded)")));
                    if (unloadedAdElms.length) {
                        window.ethicalads.load();
                    }
                }
            }));
            hook.ready((function() {
                var scriptElm = document.createElement("script");
                scriptElm.src = settings.clientURL;
                document.head.appendChild(scriptElm);
            }));
        };
        window.$docsify = window.$docsify || {};
        window.$docsify.plugins = [].concat(window.$docsify.plugins || [], docsifyEthicalAds);
    })();
})();
//# sourceMappingURL=docsify-plugin-ethicalads.js.map
